#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
def map(v, f):
    return f(v)

def foldAll(f, *args):
    return f(*args)

class PuPPy:
    
    def __init__(self, init):
        self.acc = init
        self.e1 = None
        self.e2 = None
        
    def map(self, v, f):
        return f(v)
        
    def fold(self, v, f):
        self.acc = f(self.acc, v)
        return self.acc

    def count(self, v):
        self.acc += 1
        return self.acc

    def last(self, v, n):
        if len(self.acc) >= n:
            self.acc.pop(0)
        self.acc.append(v)
        return self.acc
    
    def list(self, v):
        self.acc.append(v)
        return self.acc
    
    def iterate(self, v, f):
        self.acc = f(self.acc)
        return self.acc

    def change(self, v):
        prev, self.acc = self.acc, v
        return (prev, self.acc)

    def e_or(self, e1, e2):
        if (e1 != self.e1):
            self.e1 = e1
            return self.e1
        if (e2 != self.e2):
            self.e2 = e2
            return self.e2
        return None

    def e_and(self, v, f):
        if f(v):
            self.e1 = v
        return self.e1
