#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
import puppy as p

class Test:
    """
    >>> t = Test()
    >>> t.setV1(10)
    >>> t.now() # cannot know which triggers this
    10
    >>> t.setV2("Changed")
    >>> t.now()
    Changed
    >>> t.setV3(False)
    >>> t.now()
    False
    """
    v1 = 1
    v2 = "Test"
    v3 = True
    collection = [v1, v2, v3]
    pupush anyChanged = p.flatten(collection)

    def setV1(self, v1):
        self.v1 = v1

    def setV2(self, v2):
        self.v2 = v2

    def setV3(self, v3):
        self.v3 = v3

    def now(self):
        print("v1 =", self.v1, "v2 =", self.v2, "v3 =", self.v3)

if __name__ == "__main__":
    import doctest
    doctest.testmod()
