#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
import puppy

class Test:
    """
    >>> t = Test()
    >>> t.fireE1(1)
    1
    >>> t.fireE2(2) # cannot know which triggers this
    2
    """
    e1 = 0
    e2 = 0
    p = puppy.PuPPy(0)
    pupush e1_OR_e2 = p.e_or(e1, e2)
    pupush o1 = p.map(e1_OR_e2, lambda x : print(x))
    
    def fireE1(self, n):
        self.e1 = n

    def fireE2(self, n):
        self.e2 = n

if __name__ == "__main__":
    import doctest
    doctest.testmod()
